// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MaxFight.h"

#include "MainFrm.h"
#include "HelpDlg.h"
#include <process.h>
#include <mmsystem.h>

// ... Make sure linker uses the the multi media library
#pragma comment(lib, "winmm.lib ")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//------------------------------------------------------
#define PAUSE_SEC 500

// Game thread
void StartGame(void *lpParam)
{
	CMainFrame *pMainFrm= (CMainFrame*) lpParam;
	if(!pMainFrm)
		return;

	// set first program to execute
	int nHitPart;
	bool bProgCont, bGameOver= false;
	int nCurProg1= 0, nCurProg2= 0;
	int nCurMove1= 0, nCurMove2= 0;

	pMainFrm->OnStartGame(true);
	pMainFrm->SetCounters(0, 0);

	// set current program to -1 to start from beginning
	ProgHuman.SetNextProgBeg(nCurProg1);
	ProgEnemy.SetNextProgBeg(nCurProg2);
	
	Human.SetBodyOrig();
	Enemy.SetBodyOrig();
	Human.SetPosition( CPoint(150, VERT_POS) );
	Enemy.SetPosition( CPoint(400, VERT_POS) );
	Human.ClearPartsMoved();
	Enemy.ClearPartsMoved();
	pMainFrm->m_SelectDlg.RedrawScene();
	
	while(!pMainFrm->m_bFinish){
		if(pMainFrm->m_bPause){
			// wait when pause
			Sleep(10);
			continue;
		}
		
		//---------- 1-st Player ----------- 
		// make 1 move at a time
		// nCurProg1 = program vecOperators with array of next progs vecNextProgs
		bProgCont= ProgHuman.ExecProgram(nCurProg1, nCurMove1, Human, Enemy, nHitPart);
		
		if(nHitPart >= 0 && nHitPart < 3){
			// was Hit to Body - count it
			pMainFrm->SetCounters( pMainFrm->GetCntPlayer1()+1, pMainFrm->GetCntPlayer2() );
			PlaySound(MAKEINTRESOURCE(IDW_HIT), NULL, SND_ASYNC | SND_RESOURCE);
		}

		if(!bProgCont){
			// search IF with bigger true conditions
			if( ProgHuman.FindMostIf(nCurProg1, Enemy) ){
				// found IF - continue in next loop
				// set to first next program
				ProgHuman.SetNextProgBeg(nCurProg1);
				nCurMove1= 0;
			}
			// if no IF - search Action moves
			else if( ProgHuman.FindNextAction(nCurProg1) ){
				// start from 1-st next program
				ProgHuman.SetNextProgBeg(nCurProg1);
				nCurMove1= 0;
			}
			else{
				if(nCurProg1 == 0)
					// no more programs - stop game
					bGameOver= true;

				// Actions ended - return to parent program
				nCurProg1= ProgHuman.GetParentProg(nCurProg1);
				nCurMove1= -1; // don't execute parent prog - it already was
			}
		}

		//---------- 2-nd Player ----------- 

		bProgCont= ProgEnemy.ExecProgram(nCurProg2, nCurMove2, Enemy, Human, nHitPart);

		if(nHitPart >= 0 && nHitPart < 3){
			pMainFrm->SetCounters( pMainFrm->GetCntPlayer1(), pMainFrm->GetCntPlayer2()+1 );
			PlaySound(MAKEINTRESOURCE(IDW_HIT), NULL, SND_ASYNC | SND_RESOURCE);
		}

		if(!bProgCont){
			// search IF with bigger true conditions
			if( ProgEnemy.FindMostIf(nCurProg2, Human) ){
				// found IF - continue in next loop
				
				// set to first next program
				ProgEnemy.SetNextProgBeg(nCurProg2);
				nCurMove2= 0;
			}
			// if no IF - search Action moves
			else if( ProgEnemy.FindNextAction(nCurProg2) ){
				ProgEnemy.SetNextProgBeg(nCurProg2);
				nCurMove2= 0;
			}
			else{
				if(nCurProg2 == 0)
					// no more programs - stop game
					bGameOver= true;
				// Actions ended - return to parent program
				nCurProg2= ProgEnemy.GetParentProg(nCurProg2);
				nCurMove2= -1;
			}
		}
		//---------------------

		// Highlight currently executed program and operator
		ProgHuman.m_nCurProg= nCurProg1, ProgHuman.m_nCurMove= nCurMove1;
		ProgEnemy.m_nCurProg= nCurProg2, ProgEnemy.m_nCurMove= nCurMove2;

		// select current program if it's not shown
		int nPrParent= ProgHuman.vecPrograms[nCurProg1].nProgParent;
		ProgHuman.SelectChildProg(nPrParent, nCurProg1);
		nPrParent= ProgEnemy.vecPrograms[nCurProg2].nProgParent;
		ProgEnemy.SelectChildProg(nPrParent, nCurProg2);

		pMainFrm->m_ProgramDlg.RedrawWindow();

		if(bGameOver)
			break;
		Sleep(PAUSE_SEC * NSpeedMult); // wait for 1 sec
	}

	if(pMainFrm->GetCntPlayer1() > pMainFrm->GetCntPlayer2() )
		pMainFrm->SetGameCnts(pMainFrm->GetCntGames1() + 1, pMainFrm->GetCntGames2() );
	else if(pMainFrm->GetCntPlayer1() < pMainFrm->GetCntPlayer2() )
		pMainFrm->SetGameCnts(pMainFrm->GetCntGames1(), pMainFrm->GetCntGames2() + 1 );

	pMainFrm->OnStartGame(false);
	pMainFrm->hThread=0;
	pMainFrm->m_bFinish= true;
	_endthread();
}
//------------------------------------------------------

// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_BN_CLICKED(IDC_BUT_ADDPROG, OnButAddProg)
	ON_BN_CLICKED(IDC_BUT_ADDMOVE, OnButAddMove)
	ON_BN_CLICKED(IDC_BUT_ADDDESC, OnButAddDescen)
	ON_BN_CLICKED(IDC_BUT_DELPROG, OnButDelProg)
	ON_BN_CLICKED(IDC_BUT_DELMOVE, OnButDelMove)
	ON_BN_CLICKED(IDC_BUT_START, OnButStart)
	ON_BN_CLICKED(IDC_BUT_END_PROGR, OnButEndProgr)
	ON_BN_CLICKED(IDC_BUT_FINISH, OnButFinish)
	ON_WM_CLOSE()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_OPEN2, OnFileOpen2)
	ON_COMMAND(ID_FILE_SAVE2, OnFileSave2)
	ON_COMMAND(IDC_GAME_PAUSE1, OnGamePause1)
	ON_COMMAND(IDC_GAME_PAUSE2, OnGamePause2)
	ON_COMMAND(IDC_GAME_PAUSE3, OnGamePause3)
	ON_UPDATE_COMMAND_UI(IDC_GAME_PAUSE1, OnUpdateGamePause1)
	ON_UPDATE_COMMAND_UI(IDC_GAME_PAUSE2, OnUpdateGamePause2)
	ON_UPDATE_COMMAND_UI(IDC_GAME_PAUSE3, OnUpdateGamePause3)
	ON_COMMAND(IDC_GAME_PAUSE4, OnGamePause4)
	ON_UPDATE_COMMAND_UI(IDC_GAME_PAUSE4, OnUpdateGamePause4)
	ON_COMMAND(ID_APP_HELP, OnAppHelp)
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_OPER1, IDC_OPER7, OnSelectOperat)
	ON_CONTROL_RANGE(BN_DOUBLECLICKED, IDC_OPER1, IDC_OPER7, OnDoubleOperat1)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_nCurPart= m_nCurMove= 0;
	hThread= 0;
	m_bFinish= true;
	m_bPause= false;
	m_CurMan= NULL;
	m_CntPlayer1= m_CntPlayer2= 0;
	m_CntGames1= m_CntGames2= 0;
}

CMainFrame::~CMainFrame()
{
}
//------------------------------------------------------

// Start Game
void CMainFrame::OnButStart() 
{
	if(!m_bFinish)
		// not finished last game
		return;

	m_bFinish= false;
	m_bPause= false;
	if(!hThread)
		hThread= (HANDLE)_beginthread(StartGame, 0, this);
}

// Pause current move
void CMainFrame::OnButEndProgr() 
{
	m_bPause= !m_bPause;
}

// Finish Game
void CMainFrame::OnButFinish() 
{
	CloseHandle(hThread);
	hThread= 0;
	m_bFinish= true;
	OnStartGame(false);
}
//------------------------------------------------------

void CMainFrame::OnStartGame(bool bStart)
{
	m_SelectDlg.OnStartGame(bStart);
	m_SelectDlg.RedrawScene();
	
	CString strRes;
	strRes.Format("Score: %d : %d , Games: %d : %d", m_CntPlayer1, m_CntPlayer2, m_CntGames1, m_CntGames2);
	m_wndStatusBar.SetPaneText(0, strRes, TRUE);
	m_wndStatusBar.RedrawWindow();
}
//------------------------------------------------------

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_ProgramDlg.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_SelectDlg.Create(this, IDD_SELECT_DLG, CBRS_TOP, IDD_SELECT_DLG);
	m_SelectDlg.CreateControls();

	m_ProgramDlg.CreateControls();

	ProgHuman.Load( CString("Human.prg") );
	ProgEnemy.Load( CString("Enemy.prg") );

	return 0;
}
//------------------------------------------------------

void CMainFrame::OnClose() 
{
	ProgHuman.Save( CString("Human.prg") );
	ProgEnemy.Save( CString("Enemy.prg") );

	CFrameWnd::OnClose();
}
//------------------------------------------------------

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(CS_DBLCLKS, ::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1),
		LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME) ) );
	cs.cx= 900;
	cs.cy= 700;
	cs.x= cs.y= 0;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_ProgramDlg.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_ProgramDlg.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}
//------------------------------------------------------

void CMainFrame::OnSelectOperat(UINT nID)
{
	m_nPrevMove= m_nCurMove;
	m_nCurMove= nID - IDC_OPER1;
	m_ProgramDlg.SelectOperat(m_nCurMove);
}
//------------------------------------------------------

void CMainFrame::OnDoubleOperat1(UINT nID)
{
	m_ProgramDlg.SelectOperat(m_nPrevMove);
	m_nCurMove= nID - IDC_OPER1;
	m_ProgramDlg.OnButAddMove(m_nCurMove, m_nCurPart);
}
//------------------------------------------------------

void CMainFrame::OnSelectPart()
{
	m_ProgramDlg.SelectPart(m_nCurPart);
}
//------------------------------------------------------

void CMainFrame::OnButAddProg()
{
	m_ProgramDlg.OnButAddProg(m_nCurMove, m_nCurPart);
}

void CMainFrame::OnButAddMove()
{
	m_ProgramDlg.OnButAddMove(m_nCurMove, m_nCurPart);
}

void CMainFrame::OnButAddDescen()
{
	m_ProgramDlg.OnButAddDescen(m_nCurMove, m_nCurPart);
}

void CMainFrame::OnButDelProg() 
{
	m_ProgramDlg.OnButDelProg();
}

void CMainFrame::OnButDelMove() 
{
	m_ProgramDlg.OnButDelMove();
}
//------------------------------------------------------

void CMainFrame::OnFileOpen() 
{
	char szFilters[]= "MaxFight programs (*.prg)|*.prg||";
	
	CFileDialog dlgLoad(TRUE, "prg", m_defFileStr, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilters);
	if(dlgLoad.DoModal() == IDOK){
		CString strFile= dlgLoad.GetPathName();
		m_defFileStr= strFile;
		if( ProgHuman.Load(strFile) )
			AfxGetApp()->AddToRecentFileList(strFile);

		m_ProgramDlg.RedrawWindow();
	}
}

void CMainFrame::OnFileSave() 
{
	char szFilters[]= "MaxFight programs (*.prg)|*.prg||";

	CFileDialog dlgSave(FALSE, "prg", m_defFileStr, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilters);
	if(dlgSave.DoModal() == IDOK){
		CString strFile= dlgSave.GetPathName();
		ProgHuman.Save(strFile);
	}
}
//------------------------------------------------------

void CMainFrame::OnFileOpen2() 
{
	char szFilters[]= "MaxFight programs (*.prg)|*.prg||";
	
	CFileDialog dlgLoad(TRUE, "prg", m_defFileStr, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilters);
	if(dlgLoad.DoModal() == IDOK){
		CString strFile= dlgLoad.GetPathName();
		if( ProgEnemy.Load(strFile) )
			AfxGetApp()->AddToRecentFileList(strFile);

		m_ProgramDlg.RedrawWindow();
	}
}

void CMainFrame::OnFileSave2() 
{
	char szFilters[]= "MaxFight programs (*.prg)|*.prg||";

	CFileDialog dlgSave(FALSE, "prg", m_defFileStr, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilters);
	if(dlgSave.DoModal() == IDOK){
		CString strFile= dlgSave.GetPathName();
		ProgEnemy.Save(strFile);
	}
}
//------------------------------------------------------

bool CMainFrame::OpenFileStr(CString& strFile)
{
	if( GetFileAttributes(strFile) == 0xFFFFFFFF)
		return false;

	ProgHuman.Load(strFile);
	m_ProgramDlg.RedrawWindow();
	return true;
}
//------------------------------------------------------

void CMainFrame::ShowHint(CString &strHint)
{
	m_wndStatusBar.SetPaneText(0, strHint);
}
//------------------------------------------------------

void CMainFrame::OnGamePause1() 
{
	NSpeedMult= 1;
}

void CMainFrame::OnGamePause2() 
{
	NSpeedMult= 2;
}

void CMainFrame::OnGamePause3() 
{
	NSpeedMult= 3;
}

void CMainFrame::OnGamePause4() 
{
	NSpeedMult= 0;
}
//------------------------------------------------------

void CMainFrame::OnUpdateGamePause1(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(NSpeedMult == 1);
}

void CMainFrame::OnUpdateGamePause2(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(NSpeedMult == 2);
}

void CMainFrame::OnUpdateGamePause3(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(NSpeedMult == 3);
}

void CMainFrame::OnUpdateGamePause4(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(NSpeedMult == 0);
}
//------------------------------------------------------

void CMainFrame::OnAppHelp() 
{
	CHelpDlg HelpDlg;
	HelpDlg.DoModal();
}
//------------------------------------------------------
