// MainFrm.h : interface of the CMainFrame class

#if !defined(AFX_MAINFRM_H_INCLUDED_)
#define AFX_MAINFRM_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ProgramDlg.h"
#include "SelectDlg.h"

class CMainFrame : public CFrameWnd
{
	int m_nPrevMove;
	int m_CntPlayer1, m_CntPlayer2;
	int m_CntGames1, m_CntGames2;
	CString m_defFileStr;

public:
	CMainFrame();
	virtual ~CMainFrame();

	void OnSelectPart();
	void OnStartGame(bool bStart);
	void RedrawScene(){ m_SelectDlg.RedrawScene(); }
	void SetCounters(int nCnt1, int nCnt2){ m_CntPlayer1= nCnt1; m_CntPlayer2= nCnt2; m_SelectDlg.SetCountStr(nCnt1, nCnt2, m_CntGames1, m_CntGames2); }
	void SetGameCnts(int nCGms1, int nCGms2){ m_CntGames1= nCGms1, m_CntGames2= nCGms2; m_SelectDlg.SetCountStr(m_CntPlayer1, m_CntPlayer2, nCGms1, nCGms2); }
	int GetCntPlayer1(){ return m_CntPlayer1; }
	int GetCntPlayer2(){ return m_CntPlayer2; }
	int GetCntGames1(){ return m_CntGames1; }
	int GetCntGames2(){ return m_CntGames2; }
	bool OpenFileStr(CString& strFile);
	void ShowHint(CString &strHint);

	HANDLE hThread; // Game thread
	bool m_bFinish; // finish flag
	bool m_bPause; // pause flag

protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Operations
public:
	int m_nCurMove, m_nCurPart;
	CHuman *m_CurMan;
	CSelectDlg m_SelectDlg;
	CProgramDlg m_ProgramDlg;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnButAddProg();
	afx_msg void OnButAddMove();
	afx_msg void OnButAddDescen();
	afx_msg void OnButDelProg();
	afx_msg void OnButDelMove();
	afx_msg void OnButStart();
	afx_msg void OnButEndProgr();
	afx_msg void OnButFinish();
	afx_msg void OnClose();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnFileOpen2();
	afx_msg void OnFileSave2();
	afx_msg void OnGamePause1();
	afx_msg void OnGamePause2();
	afx_msg void OnGamePause3();
	afx_msg void OnUpdateGamePause1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGamePause2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGamePause3(CCmdUI* pCmdUI);
	afx_msg void OnGamePause4();
	afx_msg void OnUpdateGamePause4(CCmdUI* pCmdUI);
	afx_msg void OnAppHelp();
	//}}AFX_MSG
	afx_msg void OnSelectOperat(UINT nID);
	afx_msg void OnDoubleOperat1(UINT nID);

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H_INCLUDED_)
