// TreeData.cpp: implementation of the CProgramData class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "maxfight.h"

#include "ProgData.h"
#include "MainFrm.h"

#pragma warning( disable : 4786)

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// Min distance for Hit to be counted
#define MIN_HIT_DIST 5
// Distance to move enemy when hitting him
#define MOVE_HIT_DIST 40

//CString ArrOperatNames[NUM_OPERAT]= { "Attack", "Back", "Block", "Up", "Down", "Return", "If" };
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// Add Operators to Array vecOperators
CProgramData::CProgramData()
{
	RowProgram Prog1;
	vecPrograms.push_back(Prog1); // Root program

	// 3 root programs
	AddProgram(0, 0);
	AddProgram(0, 0);
	AddProgram(0, 0);

	AddProgram(vecPrograms[0].vecNextProgs[0], 0);
	AddProgram(vecPrograms[0].vecNextProgs[0], 0);

	AddProgram(vecPrograms[0].vecNextProgs[1], 0);
	AddProgram(vecPrograms[0].vecNextProgs[1], 0);

	AddProgram(vecPrograms[0].vecNextProgs[2], 0);

	m_nCurProg= m_nCurMove= -1;
}

CProgramData::~CProgramData()
{
}
//------------------------------------------------------

// Execute program for Man1 and test for hit to Man2
// return false - no operator left in current program
// bIfWasTrue = false - if IF operator was false
bool CProgramData::ExecProgram(int &nProgExec, int &nMoveExec, CHuman& Man1, CHuman& Man2, int &nHitPart)
{
	nHitPart= -1;
	int nProgs= vecPrograms.size();
	if(nProgExec >= nProgs)
		return false;

	int nPart, nMoveType, nCntHit, nCntMove, xBeg, xBeg2;
	bool bBack;

	// Take next operator and apply it to Human
	vector<OperatStruct> &vecOperats= vecPrograms[nProgExec].vecOperators;

	if(nMoveExec >= vecOperats.size())
		// operators ended
		return false;

	nMoveType= vecOperats[nMoveExec].m_nMoveType;
	nPart= vecOperats[nMoveExec].m_nPart;
	// go to next Move
	nMoveExec++;

	if(nMoveType == IF_OPER){
		if(nMoveExec + 1 >= vecOperats.size() )
			// Error - there should be 2 oper after
			return false;

		nPart= vecOperats[nMoveExec].m_nPart;
		nMoveExec++;
		nMoveType= vecOperats[nMoveExec].m_nMoveType;
		nMoveExec++;
		
		if( Man2.IsPartMoved(nPart, nMoveType) )
			// IF = true, last Move was nMoveType
			// Recursion to next Move
			return ExecProgram(nProgExec, nMoveExec, Man1, Man2, nHitPart);
		else
			// IF = false
			return false;
	}
	else{
		// 1-st goes a Part of body
		if(nMoveType != -1 || nPart < 0 || nPart >= NUM_PARTS)
			// Error - it must be a Part
			return false;

		nMoveType= vecOperats[nMoveExec].m_nMoveType;
		nMoveExec++;

		CMainFrame *pMainFrm= (CMainFrame*) AfxGetMainWnd();
		//------------ Main Part ---------------
		// execute Move for nPart part of body
		nCntHit= nCntMove= 0;
		xBeg= Man1.GetPosition().x;
		while( !Man1.MakeMove(nPart, nMoveType, Man2, xBeg) ){
			// make a little move and redraw Man1 until move is done
			Man1.SetActive();
			pMainFrm->RedrawScene();
			Man1.SetActive(false);
			// count Distance of Move
			nCntHit++;
			
			// test if move produced a hit
			if( TestHit(Man1, Man2, nPart, nHitPart) ){
				if(nHitPart >= 0 && nHitPart < 3)
					// don't count Hit Distance when touching Body (nHitPart = Body)
					nCntHit--;

				// if Move = Attack - move nHitPart of an Enemy Back
				bBack= false;
				xBeg2= Man2.GetPosition().x;
				if(nMoveType == opAttack || nMoveType == opBlock || nMoveType == opUp){
					if(nHitPart >= 0 && nHitPart < 3)
						// move Body Back
						Man2.MakeMove(nHitPart, opBack, Man1, xBeg2);
					else
						// other parts Up
						Man2.MakeMove(nHitPart, opUp, Man1, xBeg2);
					bBack= true;
				}
				else if(nMoveType == opBack || nMoveType == opDown)
					Man2.MakeMove(nHitPart, nMoveType, Man1, xBeg2), bBack= true;

				if(bBack){
					// enemy was moved
					Man1.SetActive();
					pMainFrm->RedrawScene();
					Man1.SetActive(false);
					
					nCntMove++;
					if(nCntMove >= MOVE_HIT_DIST){
						// move an Enemy only at some Distance
						nHitPart= -1; // it was only move
						break;
					}
				}

				if(nCntHit >= MIN_HIT_DIST && nHitPart >= 0 && nHitPart < 3)
					// Yes - Hit an Enemy
					break;
				else
					// count hit only when distance of move was long enough >= 10
					nHitPart= -1;
			}
		}
		//--------------------------------------

		Man1.SetPartMoved(nPart, nMoveType);
		pMainFrm->RedrawScene();
	}
	
	return true;
}
//------------------------------------------------------

// Test for Hit of several parts of Man1 to parts of Man2
bool CProgramData::TestHit(CHuman &Man1, CHuman &Man2, int nPart, int &nHitPart)
{
	int nPart1= nPart/3 *3, i;
	nHitPart= -1;
	bool bFound= false;

	if(nPart1 == 0){
		// it's a body - test all parts from legs to body
		for(i= NUM_PARTS-1; i >= 0; i--)
			if( TestHit1(Man1, Man2, i, nHitPart) ){
				bFound= true;
				if(nHitPart >= 0 && nHitPart < 3)
					// hit body - exit
					return true;
			}
	}
	else{
		// test all 3 parts of arm or leg
		for(i= nPart1; i < nPart1+3; i++)
			if( TestHit1(Man1, Man2, i, nHitPart) ){
				bFound= true;
				if(nHitPart >= 0 && nHitPart < 3)
					return true;
			}
	}
	return bFound;
}
//------------------------------------------------------

// Test for Hit of nPart of Man1 to all parts of Man2
// Return true - was hit
bool CProgramData::TestHit1(CHuman &Man1, CHuman &Man2, int nPart, int &nHitPart)
{
	int i, p1, p2, p12, p22;
	CPartBody *pPart1= Man1.GetPart(nPart);
	CPartBody *pPart2;
	
	// test all parts of body of Man2
	for(i= 0; i < NUM_PARTS; i++){
		pPart2= Man2.GetPart(i);
		
		// test all lines of all parts of Man2 for intersection with lines of nPart of Man1
		for(p1= 0; p1 < NUM_POINTS; p1++){
			p12= p1+1;
			if(p1 == NUM_POINTS-1)
				p12= 0;
			
			for(p2= 0; p2 < NUM_POINTS; p2++){
				p22= p2+1;
				if(p2 == NUM_POINTS-1)
					p22= 0;
				if( LinesIntersect(pPart1->m_WinCoords[p1], pPart1->m_WinCoords[p12],
					pPart2->m_WinCoords[p2], pPart2->m_WinCoords[p22]) )
				{
					nHitPart= i;
					return true;
				}
			}
		}
	}
	return false;
}
//------------------------------------------------------

// search IF with bigger true conditions
// returns false - not found, set nProg1 = found program with max number of true IF
bool CProgramData::FindMostIf(int &nProg1, CHuman &Man2)
{
	if(nProg1 >= vecPrograms.size() )
		return false;

	int i, nextPr, numOper, nOper, nPart, nMoveType;
	int nMaxIf= 0, nPrMax, numIf;
	bool bTrueCond;
	int numNext= vecPrograms[nProg1].vecNextProgs.size();

	// test all next programs
	// Find child IF = true
	for(i= 0; i < numNext; i++){
		nextPr= vecPrograms[nProg1].vecNextProgs[i];
		if(nextPr == vecPrograms[nProg1].nCurIfProg)
			// don't take prev program again
			continue;
	
		vector<OperatStruct> &vecOperats= vecPrograms[nextPr].vecOperators;
		numOper= vecOperats.size();
		
		numIf= 0;
		bTrueCond= true;
		for(nOper= 0; nOper < numOper; nOper++){
			if( vecOperats[nOper].m_nMoveType == IF_OPER){
				// test only IF conditions
				nOper++;
				nPart= vecOperats[nOper].m_nPart;
				nOper++;
				nMoveType= vecOperats[nOper].m_nMoveType;

				if( Man2.IsPartMoved(nPart, nMoveType) )
					numIf++;
				else{
					// only true conditions
					bTrueCond= false;
					break;
				}
			}
			else
				break;
		} // for(nOper=
		if(bTrueCond && numIf > nMaxIf)
			nMaxIf= numIf, nPrMax= nextPr;
	}

	if(nMaxIf > 0){
		// store current If prog
		vecPrograms[nProg1].nCurIfProg= nPrMax;
		nProg1= nPrMax;
		return true;
	}
	
	return false;
}

//------------------------------------------------------

// search next Action program
// sets nProg1 = found next program
bool CProgramData::FindNextAction(int &nProg1)
{
	if(nProg1 >= vecPrograms.size() )
		return false;

	int i, nextPr;
	int numNext= vecPrograms[nProg1].vecNextProgs.size();

	// test all next programs
	i= vecPrograms[nProg1].nCurProgram;
	for(i++; i < numNext; i++){
		nextPr= vecPrograms[nProg1].vecNextProgs[i];
		vector<OperatStruct> &vecOperats= vecPrograms[nextPr].vecOperators;

		if( vecOperats.size() > 0 && vecOperats[0].m_nMoveType != IF_OPER){
			// set Current Program to found prog
			vecPrograms[nProg1].nCurProgram= i;
			nProg1= nextPr;
			return true;
		}
	} // for(i=

	return false;
}
//------------------------------------------------------

void CProgramData::AddProgram(int nProg1, int nMove1, int nPart1)
{
	int nProgs= vecPrograms.size();
	if(nProg1 >= nProgs)
		return;

	RowProgram Prog1;
	vecPrograms[nProg1].vecNextProgs.push_back(nProgs);
	Prog1.nProgParent= nProg1;

	vecPrograms.push_back(Prog1);

	AddOperator(nProgs, 0, nMove1, nPart1);
}
//------------------------------------------------------

void CProgramData::AddOperator(int nProg1, int nOper1, int nMove1, int nPart1)
{
	if(nProg1 >= vecPrograms.size() )
		return;

	vector<OperatStruct> &vecOperats= vecPrograms[nProg1].vecOperators;
	OperatStruct Operat1;

	int nPos= nOper1;
	if(nPos < vecOperats.size()){
		// find exact position after selected nOper1
		if(vecOperats[nPos].m_nMoveType == -1)
			nPos++;
		else if(vecOperats[nPos].m_nMoveType == IF_OPER)
			// for IF
			nPos += 2;
		// now nPos = Move
		nPos++; // point to next operator
	}

	if(nPos > vecOperats.size())
		nPos= vecOperats.size();

	if(nMove1 == IF_OPER){
		Operat1.m_nMoveType= nMove1;
		vecOperats.insert(vecOperats.begin() + nPos, Operat1);
		nMove1= 0;
		nPos++;
	}

	// first goes Part of Body
	Operat1.m_nPart= nPart1;
	Operat1.m_nMoveType= -1;
	vecOperats.insert(vecOperats.begin() + nPos, Operat1);
	nPos++;

	// 2-nd - Move type
	Operat1.m_nPart= -1;
	Operat1.m_nMoveType= nMove1;
	vecOperats.insert(vecOperats.begin() + nPos, Operat1);
}
//------------------------------------------------------

// delete program nProg1 and all it's children
void CProgramData::DelProgram(int nProg1)
{
	if(nProg1 >= vecPrograms.size() || vecPrograms.size() <= 1)
		return;

	// delete pointer of parent to nProg1
	int nPrParent= vecPrograms[nProg1].nProgParent;
	int numNext= vecPrograms[nPrParent].vecNextProgs.size();
	if( !nPrParent && numNext <= 1)
		// don't delete last program
		return;
	
	// delete nProg1 and it's children
	DelProgr1(nProg1);

	for(int i= 0; i < numNext; i++){
		if(vecPrograms[nPrParent].vecNextProgs[i] == nProg1){
			vecPrograms[nPrParent].vecNextProgs.erase(vecPrograms[nPrParent].vecNextProgs.begin() + i);
			break;
		}
	}

	// select 1-st program after deleting child
	vecPrograms[nPrParent].nProgramSel= 0;
}
//------------------------------------------------------

// recursive function
void CProgramData::DelProgr1(int nProg1)
{
	if(nProg1 >= vecPrograms.size() )
		return;

	int nPr1;
	int numNext= vecPrograms[nProg1].vecNextProgs.size();
	int iNext, indNextPr;

	for(iNext= 0; iNext < numNext; iNext++){
		// if there is a child - process it first (make recursion)
		indNextPr= vecPrograms[nProg1].vecNextProgs[iNext];
		if(indNextPr)
			DelProgr1(indNextPr);
	}
	// after deleting all childs - delete row
	vecPrograms.erase(vecPrograms.begin() + nProg1);
	
	// now decrease all references to rows after nProg1
	int nProgs= vecPrograms.size();

	for(nPr1= 0; nPr1 < nProgs; nPr1++){
		numNext= vecPrograms[nPr1].vecNextProgs.size();
		for(iNext= 0; iNext < numNext; iNext++){
			if(vecPrograms[nPr1].vecNextProgs[iNext] > nProg1)
				vecPrograms[nPr1].vecNextProgs[iNext]--;
		}

		// decrease pointers to parents after nProg1
		if(vecPrograms[nPr1].nProgParent > nProg1)
			vecPrograms[nPr1].nProgParent--;
	}
}
//------------------------------------------------------

void CProgramData::DelOperator(int nProg1, int nOper1)
{
	if(nProg1 >= vecPrograms.size() )
		return;

	vector<OperatStruct> &vecOperats= vecPrograms[nProg1].vecOperators;
	if(vecOperats.size() < 4)
		// don't delete last Move
		return;
	if(nOper1 < vecOperats.size() ){
		if(vecOperats[nOper1].m_nMoveType == IF_OPER)
			// delete all 3 oper after
			vecOperats.erase(vecOperats.begin() + nOper1, vecOperats.begin() + nOper1+3);
		else{
			if(vecOperats[nOper1].m_nPart == -1)
				// it's part - delete 1 oper before
				nOper1--;

			// delete 2 after
			vecOperats.erase(vecOperats.begin() + nOper1, vecOperats.begin() + nOper1+2);

			if(nOper1 > 0 && vecOperats[nOper1-1].m_nMoveType == IF_OPER)
				// delete IF
				vecOperats.erase(vecOperats.begin() + nOper1-1);
		}
	}
}
//------------------------------------------------------

bool CProgramData::Save(CString& strFile)
{
	ofstream out(strFile, ios::out | ios::binary); 

    if(!out)
		return false;

	BYTE version= 0xAD;
	WORD sizeProgs= vecPrograms.size();
	WORD numOper, numNext;
	int nProg, nOper;
	int iNext, indNextPr;

	// write BYTE of version
    out.write((char *) &version, sizeof(version));

	// write num of rows
    out.write((char *) &sizeProgs, sizeof(sizeProgs));
	
	for(nProg= 0; nProg < sizeProgs; nProg++){
	    out.write((char *) &vecPrograms[nProg].nProgramSel, sizeof(int));
	    out.write((char *) &vecPrograms[nProg].nProgParent, sizeof(int));

		// write number of next program
		numNext= vecPrograms[nProg].vecNextProgs.size();
	    out.write((char *) &numNext, sizeof(numNext));
		
		// write each next program
		for(iNext= 0; iNext < numNext; iNext++){
			indNextPr= vecPrograms[nProg].vecNextProgs[iNext];
			// write data
		    out.write((char *) &indNextPr, sizeof(indNextPr));
		}
		//------------------
		
		// write number of operators in a program
		numOper= vecPrograms[nProg].vecOperators.size();
	    out.write((char *) &numOper, sizeof(numOper));
		
		// write each oper
		for(nOper= 0; nOper < numOper; nOper++){
			OperatStruct& Operat1= vecPrograms[nProg].vecOperators[nOper];
			// write data
		    out.write((char *) &Operat1, sizeof(OperatStruct) );
		}
	    if(!out)
			break;
	}

    out.close();
    if(!out)
		return false;

	return true;
}
//------------------------------------------------------

bool CProgramData::Load(CString& strFile)
{
	ifstream in(strFile, ios::in | ios::binary); 

    if(!in)
		return false;

	BYTE version;
	WORD sizeProgs;
	WORD numOper, numNext;
	int nProg, nOper, indNextPr, iNext;

	// read BYTE of version
    in.read((char *) &version, sizeof(version));
	if(version != 0xAD)
		return false;

	// delete all data
	vecPrograms.erase(vecPrograms.begin(), vecPrograms.end() );

	// read num of rows
    in.read((char *) &sizeProgs, sizeof(sizeProgs));
	
	OperatStruct Operat1;
	RowProgram Prog1;
	for(nProg= 0; nProg < sizeProgs; nProg++){
		// insert program
		vecPrograms.push_back(Prog1);

	    in.read((char *) &vecPrograms[nProg].nProgramSel, sizeof(int));
	    in.read((char *) &vecPrograms[nProg].nProgParent, sizeof(int));

		// read number of next program
	    in.read((char *) &numNext, sizeof(numNext));
		// read each next program
		for(iNext= 0; iNext < numNext; iNext++){
			// read data
		    in.read((char *) &indNextPr, sizeof(indNextPr));
			vecPrograms[nProg].vecNextProgs.push_back(indNextPr);
		}

		// read number of operators in i row
	    in.read((char *) &numOper, sizeof(numOper));
		// read each oper
		for(nOper= 0; nOper < numOper; nOper++){
			// read data
		    in.read((char *) &Operat1, sizeof(OperatStruct) );
			vecPrograms[nProg].vecOperators.push_back(Operat1);
			if(!in)
				break;
		}
	    if(!in)
			break;
	}

    in.close();
    if(!in)
		return false;

	return true;
}
//------------------------------------------------------

// select child program that = N of nChild in vecPrograms
void CProgramData::SelectChildProg(int nPrParent, int nChild)
{
	int i, nRows= vecPrograms[nPrParent].vecNextProgs.size();
	
	// test child programs
	for(i= 0; i < nRows; i++){
		if(vecPrograms[nPrParent].vecNextProgs[i] == nChild)
			vecPrograms[nPrParent].nProgramSel= i;
	}
}
//------------------------------------------------------

// The following 2 functions are based on an algorithm presented in "Algorithms" by Robert Sedgewick, Addison-Wesley, 1988
// Determines if two line segments intersect
// RETURN true - if they intersect, FALSE if not
bool CProgramData::LinesIntersect(CPoint &p1, CPoint &p2, CPoint &p3, CPoint &p4)
{ 
   return ( (( CCW(p1, p2, p3) * CCW(p1, p2, p4)) <= 0) &&
			(( CCW(p3, p4, p1) * CCW(p3, p4, p2)  <= 0)) );
}
//------------------------------------------------------

// CCW (CounterClockWise)
// Determines, given three points, if when travelling from the first to
// the second to the third, we travel in a counterclockwise direction.
// RETURN 1 if the movement is in a counterclockwise direction, -1 if not
int CProgramData::CCW(CPoint &p0, CPoint &p1, CPoint &p2)
{ 
   LONG dx1, dx2;
   LONG dy1, dy2;
   dx1= p1.x - p0.x;
   dx2= p2.x - p0.x;

   dy1= p1.y - p0.y;
   dy2= p2.y - p0.y;
   return ((dx1 * dy2 > dy1 * dx2) ? 1 : -1);
} 
//------------------------------------------------------
