#if !defined(AFX_TREEDATA_H_INCLUDED_)
#define AFX_TREEDATA_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include <fstream>
using namespace std;

#include "Human.h"

#define NUM_OPERAT 7
#define IF_OPER NUM_OPERAT-1

// structure for one element in the tree
// first goes m_nPart operator, then m_nMoveType operatror
// IF goes before these 2 operators if it's IF oper
struct OperatStruct
{
	int m_nPart; // N of part of Body - 1-st in program
	int m_nMoveType; // Move type - 2-nd
	bool m_bCondit; // DO - 0, IF - 1

	OperatStruct(){ m_nPart= m_nMoveType= -1; m_bCondit= 0; }
};

struct RowProgram
{
	// vector of elements which may refer to other rows
	vector<OperatStruct> vecOperators;
	// array of child programs - ind in vecPrograms
	vector<int> vecNextProgs;
	// Current N of program in vecNextProgs to execute
	int nCurProgram;
	// Current N of IF program in vecNextProgs to execute
	int nCurIfProg;
	// N of program in vecNextProgs selected in window
	int nProgramSel;
	// parent program - for selecting child program
	int nProgParent;
	
	// rect in window of this program
	CRect coordRect;
	RowProgram(){ nCurProgram= nCurIfProg= nProgramSel= 0; nProgParent= 0; }
};

class CProgramData  
{
	bool TestHit(CHuman &Man1, CHuman &Man2, int nPart, int &nHitPart);
	bool TestHit1(CHuman &Man1, CHuman &Man2, int nPart, int &nHitPart);
	bool LinesIntersect(CPoint &p1, CPoint &p2, CPoint &p3, CPoint &p4);
	int CCW(CPoint &p0, CPoint &p1, CPoint &p2);
	//int GetFirstChildProg(int nProg1){ if(nProg1 < vecPrograms.size() && vecPrograms[nProg1].vecNextProgs.size() > 0) return vecPrograms[nProg1].vecNextProgs[0]; return 0; }

public:
	CProgramData();
	virtual ~CProgramData();

	bool ExecProgram(int &nProgExec, int &nMoveExec, CHuman& Man1, CHuman& Man2, int &nHitPart);
	bool FindMostIf(int &nProg1, CHuman& Man2);
	bool FindNextAction(int &nProg1);
	void SetNextProgBeg(int nProg1){ if(nProg1 < vecPrograms.size()){ vecPrograms[nProg1].nCurProgram= -1; vecPrograms[nProg1].nCurIfProg= -1; } }
	int GetParentProg(int nProg1){ if(nProg1 < vecPrograms.size()) return vecPrograms[nProg1].nProgParent; return 0; }

	void AddProgram(int nProg1, int nMove1, int nPart= 0);
	void AddOperator(int nProg1, int nOper1, int nMove1, int nPart1);
	void DelProgram(int nProg1);
	void DelProgr1(int nProg1);
	void DelOperator(int nProg1, int nOper1);
	void SelectChildProg(int nPrParent, int nChild);
	
	// save array vecItems and string to file
	bool Load(CString& strFile);
	// load array vecItems and string from file
	bool Save(CString& strFile);
	
public:
	// vector of programs (0 row - root items)
	vector<RowProgram> vecPrograms;
	
	//vector<OperatStruct> vecOperators; // Select Operators
	int m_nCurProg, m_nCurMove;
};

extern CProgramData ProgHuman, ProgEnemy, *CurProg;
//extern CString ArrOperatNames[NUM_OPERAT];

#endif // !defined(AFX_TREEDATA_H_INCLUDED_)
