// ProgramDlg.cpp : implementation file
//

#include "stdafx.h"
#include "maxfight.h"
#include "ProgramDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProgramDlg dialog


CProgramDlg::CProgramDlg(CWnd* pParent /*=NULL*/)
{
	//{{AFX_DATA_INIT(CProgramDlg)
	//}}AFX_DATA_INIT
	m_nCurProg= 1, m_nCurOper= 0;
	m_pCurTree= &m_wndProgTree;
}


void CProgramDlg::DoDataExchange(CDataExchange* pDX)
{
	//{{AFX_DATA_MAP(CProgramDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProgramDlg, CWnd)
	//{{AFX_MSG_MAP(CProgramDlg)
	ON_WM_SIZE()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgramDlg message handlers

void CProgramDlg::CreateControls()
{
	CRect rcClient;
	GetClientRect(&rcClient);
	rcClient.right= rcClient.right / 2 - 2;
	m_wndProgTree.m_pProg= &ProgHuman;
	m_wndProgTree.Create(NULL, NULL, WS_CHILD | WS_VISIBLE, rcClient, this, IDC_PROG_TREE);

	rcClient.right= rcClient.right * 2 + 4;
	m_wndProgTree2.m_pProg= &ProgEnemy;
	m_wndProgTree2.Create(NULL, NULL, WS_CHILD | WS_VISIBLE, rcClient, this, IDC_PROG_TREE2);
}
//------------------------------------------------------

void CProgramDlg::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	
	if(m_wndProgTree){
		CRect rect;
		GetClientRect(&rect);
		m_wndProgTree.SetWindowPos(NULL, 0, 0, rect.right/2-1, rect.bottom, SWP_NOZORDER | SWP_SHOWWINDOW);
		m_wndProgTree.CreateScrolls();

		m_wndProgTree2.SetWindowPos(NULL, rect.right/2 +1, 0, rect.right/2 -1, rect.bottom, SWP_NOZORDER | SWP_SHOWWINDOW);
		m_wndProgTree2.CreateScrolls();
	}
}
//------------------------------------------------------

void CProgramDlg::OnButAddProg(int nMove1, int nPart1)
{
	if(m_nCurProg < CurProg->vecPrograms.size() ){
		int nPrParent= CurProg->vecPrograms[m_nCurProg].nProgParent;
		CurProg->AddProgram(nPrParent, nMove1, nPart1);

		m_pCurTree->CreateScrolls();
	}
}

void CProgramDlg::OnButAddMove(int nMove1, int nPart1)
{
	CurProg->AddOperator(m_nCurProg, m_nCurOper, nMove1, nPart1);
	m_nCurOper += 2;
	if(nMove1 == IF_OPER)
		m_nCurOper++;
	m_pCurTree->m_nCurOper= m_nCurOper;

	m_pCurTree->CreateScrolls();
}

void CProgramDlg::OnButAddDescen(int nMove1, int nPart1) 
{
	CurProg->AddProgram(m_nCurProg, nMove1, nPart1);

	m_pCurTree->CreateScrolls();
}

void CProgramDlg::OnButDelMove() 
{
	CurProg->DelOperator(m_nCurProg, m_nCurOper);
	
	int numOper= 0;
	if(m_nCurProg < CurProg->vecPrograms.size() )
		numOper= CurProg->vecPrograms[m_nCurProg].vecOperators.size();
	
	if(numOper > 0 && m_nCurOper >= numOper){
		m_nCurOper= numOper -1;
		m_pCurTree->m_nCurOper= m_nCurOper;
	}

	m_pCurTree->RedrawClient();
}

void CProgramDlg::OnButDelProg() 
{
	CurProg->DelProgram(m_nCurProg);
	m_pCurTree->RedrawClient();
}
//------------------------------------------------------

void CProgramDlg::SelectOperat(int nMove1)
{
	vector<OperatStruct> &vecOperats= CurProg->vecPrograms[m_nCurProg].vecOperators;
	if(m_nCurOper >= vecOperats.size() )
		return;

	if(nMove1 == vecOperats[m_nCurOper].m_nMoveType)
		return;

	if( vecOperats[m_nCurOper].m_nMoveType == -1)
		m_nCurOper++;

	if( vecOperats[m_nCurOper].m_nMoveType != -1){
		if(nMove1 == IF_OPER && m_nCurOper > 1 && vecOperats[m_nCurOper-2].m_nMoveType == IF_OPER)
			// it's already IF
			return;

		if(vecOperats[m_nCurOper].m_nMoveType == IF_OPER)
			// delete IF oper
			vecOperats.erase(vecOperats.begin() + m_nCurOper), m_nCurOper++;

		if(nMove1 == IF_OPER)
			// add IF before CurOper
			m_nCurOper--, vecOperats.insert(vecOperats.begin() + m_nCurOper);

		vecOperats[m_nCurOper].m_nMoveType= nMove1;
		m_pCurTree->m_nCurOper= m_nCurOper;
	}
	m_pCurTree->RedrawClient();
}
//------------------------------------------------------

void CProgramDlg::SelectPart(int nPart1)
{
	vector<OperatStruct> &vecOperats= CurProg->vecPrograms[m_nCurProg].vecOperators;

	if(m_nCurOper >= vecOperats.size() )
		return;

	if( vecOperats[m_nCurOper].m_nPart != -1)
		vecOperats[m_nCurOper].m_nPart = nPart1;
	else if(m_nCurOper > 0 && vecOperats[m_nCurOper-1].m_nPart != -1)
		vecOperats[m_nCurOper-1].m_nPart = nPart1;

	m_pCurTree->RedrawClient();
}
//------------------------------------------------------

void CProgramDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CRect Rect1;
	GetClientRect(&Rect1);
	
	dc.MoveTo(Rect1.right/2-1, 0);
	dc.LineTo(Rect1.right/2-1, Rect1.bottom);
	dc.MoveTo(Rect1.right/2, 0);
	dc.LineTo(Rect1.right/2, Rect1.bottom);
}
