// ProgramTree.cpp : implementation file
//

#include "stdafx.h"
#include "maxfight.h"
#include "ProgramTree.h"

#include "ProgramDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProgramTree

#define X_OFFS 10
#define Y_OFFS 10

CProgramTree::CProgramTree()
{
	m_pProg= NULL;
	m_xScrollPos= m_yScrollPos= 0;
	m_nCurProg= 1, m_nCurOper= 0;
	m_xOperSize= 0;

	for(int i= 0; i < NUM_OPERAT; i++)
		m_bmpOper[i].LoadBitmap( MAKEINTRESOURCE(IDB_OPER1+i) );
	
	for(i= 0; i < NUM_PARTS; i++)
		m_bmpBody[i].LoadBitmap( MAKEINTRESOURCE(IDB_BODY1+i) );
}

CProgramTree::~CProgramTree()
{
}

BEGIN_MESSAGE_MAP(CProgramTree, CWnd)
	//{{AFX_MSG_MAP(CProgramTree)
	ON_WM_PAINT()
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgramTree1 message handlers

void CProgramTree::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	PaintClient(dc);
}
//------------------------------------------------------

void CProgramTree::PaintClient(CDC& dc)
{
	CDC memDC, scrDC;
	CBitmap Bitmap, bmpScreen;

	CRect Rect1;
	GetClientRect(&Rect1);

	if(!memDC.CreateCompatibleDC(&dc) || !scrDC.CreateCompatibleDC(&dc))
		return;

	Bitmap.LoadBitmap( MAKEINTRESOURCE(IDB_BACKGROUND) );
	BITMAP BitMap;
	Bitmap.GetBitmap(&BitMap);

	if( !bmpScreen.CreateCompatibleBitmap(&dc, Rect1.right+BitMap.bmWidth + m_xScrollPos, Rect1.bottom+BitMap.bmHeight + m_yScrollPos) )
		return;

	// then select new picture to draw
	CBitmap* pOldBmpMem= memDC.SelectObject(&Bitmap);
	CBitmap* pOldBmpScr= scrDC.SelectObject(&bmpScreen);
	
	int nRow= 0, nCol= 0;
	for(nRow= 0; nRow*BitMap.bmHeight < Rect1.bottom+m_yScrollPos; nRow++){
		for(nCol= 0; nCol*BitMap.bmWidth < Rect1.right+m_xScrollPos; nCol++)
			scrDC.BitBlt(nCol*BitMap.bmWidth, nRow*BitMap.bmHeight, BitMap.bmWidth, BitMap.bmHeight,
				&memDC, 0, 0, SRCCOPY);
	}

	DrawProgramTree(scrDC, 0);
	dc.BitBlt(0, 0, Rect1.right, Rect1.bottom, &scrDC, m_xScrollPos, m_yScrollPos, SRCCOPY);

	if(pOldBmpMem)
		memDC.SelectObject(pOldBmpMem);
	if(pOldBmpScr)
		scrDC.SelectObject(pOldBmpScr);
}
//------------------------------------------------------

//   Scroll-
void CProgramTree::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	ScrollPicWindow(SB_VERT, nSBCode);
}

void CProgramTree::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	ScrollPicWindow(SB_HORZ, nSBCode);
}
//------------------------------------------------------

//   Scroll- 
BOOL CProgramTree::ScrollPicWindow(int nScrollBar, WORD wScrollCode)
{
    SCROLLINFO  ScrollInfo; 
	
    // Get current scroll information. 
	ScrollInfo.cbSize = sizeof(SCROLLINFO); 
    ScrollInfo.fMask = SIF_ALL; 
    GetScrollInfo(nScrollBar, &ScrollInfo); 

    // Modify scroll information based on requested 
    // scroll action. 
    switch (wScrollCode) 
    { 
	case SB_LINEDOWN: 
		ScrollInfo.nPos += 50;
		break; 
		
	case SB_LINEUP: 
		ScrollInfo.nPos -= 50;
		break; 
		
	case SB_PAGEDOWN: 
		ScrollInfo.nPos += ScrollInfo.nPage; 
		break; 
		
	case SB_PAGEUP: 
		ScrollInfo.nPos -= ScrollInfo.nPage; 
		break; 
		
	case SB_TOP: 
		ScrollInfo.nPos = ScrollInfo.nMin; 
		break; 
		
	case SB_BOTTOM: 
		ScrollInfo.nPos = ScrollInfo.nMax; 
		break; 
		
		// Don't do anything. 
	case SB_THUMBPOSITION: 
	case SB_THUMBTRACK: 
		ScrollInfo.nPos = ScrollInfo.nTrackPos; 
		break; 
		
	case SB_ENDSCROLL: 
	default: 
		return FALSE; 
    } 
	
    // Make sure that scroll position is in range. 
    if(ScrollInfo.nPos < 0) 
        ScrollInfo.nPos = 0; 
    else if(ScrollInfo.nMax - (int) ScrollInfo.nPage + 1 < ScrollInfo.nPos) 
        ScrollInfo.nPos = ScrollInfo.nMax  - ScrollInfo.nPage + 1; 
	
    // Set new scroll position. 
    ScrollInfo.fMask = SIF_POS; 
    SetScrollInfo(nScrollBar, &ScrollInfo, TRUE); 

	int xScrPos= GetScrollPos(SB_HORZ);
	int yScrPos= GetScrollPos(SB_VERT);
	ScrollWindowAt(xScrPos, yScrPos);
	RedrawClient();

    return TRUE; 
}
void CProgramTree::ScrollWindowAt(int xScroll, int yScroll)
{
	// move at distance between old and new position of scroll box
	ScrollWindow(m_xScrollPos-xScroll, m_yScrollPos-yScroll);
	
	// update new position of scrolls
	m_xScrollPos= xScroll;
	m_yScrollPos= yScroll;
}
//----------------------------------------------

void CProgramTree::CreateScrolls()
{
	// set vertical scroll if yCoord is lower bottom
	CRect rcClient;

	// get client rect without scrolls
	GetWindowRect(&rcClient);
	rcClient.OffsetRect(-rcClient.left, -rcClient.top);
	
	int xHeight, xWidth;
	int nBotOld= m_nBottomMax;

	// find max size of tree
	xHeight= GetTreeSize(0, xWidth);
	m_nBottomMax= xHeight;
	m_nRightMax= xWidth;

	// Initialize vertical scroll bar. 
	SCROLLINFO  ScrollInfo; 
	ScrollInfo.cbSize = sizeof(SCROLLINFO); 
	ScrollInfo.fMask = SIF_ALL; 
	ScrollInfo.nMin = 0; 
	ScrollInfo.nPos= m_yScrollPos;
	
	ScrollInfo.nMax = m_nBottomMax;
	ScrollInfo.nPage = rcClient.bottom;
	SetScrollInfo(SB_VERT, &ScrollInfo, TRUE); 

	//----------------------------------
	// Initialize horizontal scroll bar. 
	ScrollInfo.nPos= m_xScrollPos;

	ScrollInfo.nMax = m_nRightMax;
	ScrollInfo.nPage = rcClient.right;
	SetScrollInfo(SB_HORZ, &ScrollInfo, TRUE);

	RedrawClient();
}
//----------------------------------------------

// returns size of tree (xWidth, maxRows)
int CProgramTree::GetTreeSize(int nProg1, int& xWidth)
{
	int nProgs= m_pProg->vecPrograms.size();
	xWidth= 0;
	if(nProg1 >= nProgs)
		return 0;

	// process all child programs of current program nProg1
	int numProgs= m_pProg->vecPrograms[nProg1].vecNextProgs.size();
	int maxRows, nextPr, nextPr1, nSel, nOpSum, maxOpers= 0, maxCols= 0, nRowOpMax;
	int nRows, sumRows= 0, nCols, iNext, i, nOp;

	for(iNext= 0; iNext < numProgs; iNext++){
		nextPr= m_pProg->vecPrograms[nProg1].vecNextProgs[iNext];
		nCols= 1;
		nOpSum= m_pProg->vecPrograms[nextPr].vecOperators.size();
	
		// get all selected child programs
		maxRows= 1;
		nRows= 1;
		while(nRows){
			nSel= m_pProg->vecPrograms[nextPr].nProgramSel;
			nRows= m_pProg->vecPrograms[nextPr].vecNextProgs.size();
			
			// get max N of Opers in row of progs
			nRowOpMax= 0;
			for(i= 0; i < nRows; i++){
				nextPr1= m_pProg->vecPrograms[nextPr].vecNextProgs[i];
				nOp= m_pProg->vecPrograms[nextPr1].vecOperators.size();
				if(nOp > nRowOpMax)
					nRowOpMax= nOp;
			}

			if(nSel < nRows){
				nextPr= m_pProg->vecPrograms[nextPr].vecNextProgs[nSel];
				
				nOpSum += nRowOpMax;
				nCols++;
			}
			
			// get max number of child progs
			if(nRows > maxRows)
				maxRows= nRows;
		}
		if(nOpSum > maxOpers)
			maxOpers= nOpSum, maxCols= nCols;

		if(nProg1 == 0)
			// for root program - add max rows
			sumRows += maxRows;
	}

	CBitmap bmpOper;
	bmpOper.LoadBitmap( MAKEINTRESOURCE(IDB_OPER1) );
	BITMAP BitMap;
	bmpOper.GetBitmap(&BitMap);
	m_xOperSize= BitMap.bmWidth;
	xWidth= maxOpers *m_xOperSize + maxCols*X_OFFS + X_OFFS*2;

	if(nProg1 == 0){
		sumRows= sumRows * (m_xOperSize+Y_OFFS) + Y_OFFS*2;
		return sumRows;
	}

	maxRows= maxRows * (m_xOperSize+Y_OFFS) + Y_OFFS*2;
	return maxRows;
}
//----------------------------------------------

void CProgramTree::DrawProgramTree(CDC& dc, int nProg1)
{
	int nProgs= m_pProg->vecPrograms.size();
	if(nProg1 >= nProgs)
		return;

	CDC memDC;
	CBitmap bmpSel1, bmpSel2, bmpAct, bmpExec;

	if( !memDC.CreateCompatibleDC(&dc) )
		return;

	bmpSel1.LoadBitmap( MAKEINTRESOURCE(IDB_SEL_FONE) );
	bmpSel2.LoadBitmap( MAKEINTRESOURCE(IDB_SEL_FONE2) );
	bmpAct.LoadBitmap( MAKEINTRESOURCE(IDB_SEL_ACT) );
	bmpExec.LoadBitmap( MAKEINTRESOURCE(IDB_SEL_EXEC) );
	BITMAP BitMap;
	bmpSel1.GetBitmap(&BitMap);
	m_xOperSize= BitMap.bmWidth;

	CBitmap* pOldBmpMem= memDC.SelectObject(&m_bmpOper[0]);

	// process all child programs of current program nProg1
	int numProgs= m_pProg->vecPrograms[nProg1].vecNextProgs.size();
	int iNext, i, nextPr, nextPr1, nSel, nOp, op;
	int maxRows= 0, nRows, sumRows= 0, nPrSel;
	int xCoord, yCoord, xCoord1, tMove, yCurTop, xCoordMax, xSelEnd, nPart1;

	for(iNext= 0; iNext < numProgs; iNext++){
		nextPr= m_pProg->vecPrograms[nProg1].vecNextProgs[iNext];

		// Draw Root Programs
		xCoord= X_OFFS;
		yCoord= Y_OFFS + sumRows * (m_xOperSize+Y_OFFS);

		// Draw nextPr Program
		nOp= m_pProg->vecPrograms[nextPr].vecOperators.size();
		m_pProg->vecPrograms[nextPr].coordRect.SetRect(xCoord, yCoord, xCoord + nOp*m_xOperSize, yCoord+m_xOperSize);
		yCurTop= yCoord;

		for(op= 0; op < nOp; op++){
			tMove= m_pProg->vecPrograms[nextPr].vecOperators[op].m_nMoveType;

			if(nextPr == m_pProg->m_nCurProg && op == m_pProg->m_nCurMove)
				memDC.SelectObject( &bmpExec);
			else if(nextPr == m_nCurProg && op == m_nCurOper)
				memDC.SelectObject( &bmpAct);
			else if(tMove == -1)
				memDC.SelectObject( &bmpSel1);
			else
				memDC.SelectObject( &bmpSel2);

			dc.BitBlt(xCoord, yCoord, m_xOperSize, m_xOperSize, &memDC, 0, 0, SRCCOPY);

			if(tMove == -1){
				tMove= m_pProg->vecPrograms[nextPr].vecOperators[op].m_nPart;
				memDC.SelectObject( &m_bmpBody[tMove] );
			}
			else
				memDC.SelectObject( &m_bmpOper[tMove] );

			dc.BitBlt(xCoord+3, yCoord+3, m_xOperSize-6, m_xOperSize-6, &memDC, 3, 3, SRCCOPY);
			xCoord += m_xOperSize;
		}
		xSelEnd= xCoord;

		// get all selected child programs
		maxRows= 1;
		nRows= 1;
		nPrSel= 0;
		while(nRows){
			nSel= m_pProg->vecPrograms[nextPr].nProgramSel;
			nRows= m_pProg->vecPrograms[nextPr].vecNextProgs.size();

			xCoord += X_OFFS;
			yCoord= yCurTop;
			xCoordMax= xCoord;
			
			if(nRows){
				// Draw Line horizontal
				int yLine= yCoord + (m_xOperSize+Y_OFFS)*nPrSel + m_xOperSize/2;
				dc.MoveTo(xSelEnd, yLine);
				dc.LineTo(xCoord - X_OFFS/2 +1, yLine);

				// Draw Line vertical
				dc.MoveTo(xCoord - X_OFFS/2, yCoord + m_xOperSize/2);
				if(nRows > nPrSel)
					yLine= yCoord + m_xOperSize/2 + (m_xOperSize + Y_OFFS)*(nRows -1) +1;
				dc.LineTo(xCoord - X_OFFS/2, yLine);
			}

			// Draw all Next Programs in vecNextProgs
			for(i= 0; i < nRows; i++){
				// Draw nextPr1 Program
				nextPr1= m_pProg->vecPrograms[nextPr].vecNextProgs[i];

				nOp= m_pProg->vecPrograms[nextPr1].vecOperators.size();
				xCoord1= xCoord;
				m_pProg->vecPrograms[nextPr1].coordRect.SetRect(xCoord, yCoord, xCoord + nOp*m_xOperSize, yCoord+m_xOperSize);
				
				for(op= 0; op < nOp; op++){
					// horiz line to each progr
					dc.MoveTo(xCoord, yCoord + m_xOperSize/2);
					dc.LineTo(xCoord - X_OFFS/2, yCoord + m_xOperSize/2);
					
					tMove= m_pProg->vecPrograms[nextPr1].vecOperators[op].m_nMoveType;
					if(i == nSel){
						if(nextPr1 == m_pProg->m_nCurProg && op == m_pProg->m_nCurMove)
							memDC.SelectObject( &bmpExec);
						else if(nextPr1 == m_nCurProg && op == m_nCurOper)
							memDC.SelectObject( &bmpAct);
						else if(tMove == -1)
							memDC.SelectObject( &bmpSel1);
						else
							memDC.SelectObject( &bmpSel2);

						dc.BitBlt(xCoord1, yCoord, m_xOperSize, m_xOperSize, &memDC, 0, 0, SRCCOPY);

						if(tMove == -1){ // it's part of body
							nPart1= m_pProg->vecPrograms[nextPr1].vecOperators[op].m_nPart;
							memDC.SelectObject( &m_bmpBody[nPart1] );
						}
						else // it's MoveType
							memDC.SelectObject( &m_bmpOper[tMove] );
						dc.BitBlt(xCoord1+3, yCoord+3, m_xOperSize-6, m_xOperSize-6, &memDC, 3, 3, SRCCOPY);
					}
					else{
						if(nextPr1 == m_pProg->m_nCurProg && op == m_pProg->m_nCurMove){
							memDC.SelectObject( &bmpExec);
							dc.BitBlt(xCoord1, yCoord, m_xOperSize, m_xOperSize, &memDC, 0, 0, SRCCOPY);
						}

						if(tMove == -1){ // it's part of body
							nPart1= m_pProg->vecPrograms[nextPr1].vecOperators[op].m_nPart;
							memDC.SelectObject( &m_bmpBody[nPart1] );
						}
						else
							memDC.SelectObject( &m_bmpOper[tMove] );

						if(nextPr1 == m_pProg->m_nCurProg && op == m_pProg->m_nCurMove)
							dc.BitBlt(xCoord1+3, yCoord+3, m_xOperSize-6, m_xOperSize-6, &memDC, 3, 3, SRCCOPY);
						else
							dc.BitBlt(xCoord1, yCoord, m_xOperSize, m_xOperSize, &memDC, 0, 0, SRCCOPY);
					}
					xCoord1 += m_xOperSize;

					if(xCoord1 > xCoordMax)
						xCoordMax= xCoord1;
				}
				yCoord += m_xOperSize + Y_OFFS;
				if(i == nSel)
					xSelEnd= xCoord1;
			} // for(i= 0;
			//----------------

			if(nSel < nRows)
				nextPr= m_pProg->vecPrograms[nextPr].vecNextProgs[nSel];
			nPrSel= nSel;

			xCoord= xCoordMax;
			// get max number of child progs
			if(nRows > maxRows)
				maxRows= nRows;
		} // while(nRows)

		if(nProg1 == 0)
			// for root program - add max rows
			sumRows += maxRows;
	}

	if(pOldBmpMem)
		memDC.SelectObject(pOldBmpMem);
}
//------------------------------------------------------

// returns true if found, nProg1 - N of Program and Oper in it by Point in window
bool CProgramTree::FindOperByPoint(CPoint& point, int& nProg1, int& nOper1)
{
	int numProgs= m_pProg->vecPrograms[0].vecNextProgs.size();
	int nextPr, nSel, nRows, nextPr1, i;

	for(int iNext= 0; iNext < numProgs; iNext++){
		nextPr= m_pProg->vecPrograms[0].vecNextProgs[iNext];

		if( m_pProg->vecPrograms[nextPr].coordRect.PtInRect(point) ){
			// found program by point - find Oper1
			nProg1= nextPr;
			nOper1= (point.x - m_pProg->vecPrograms[nextPr].coordRect.left) / m_xOperSize;
			return true;
		}

		// get all selected child programs
		nRows= 1;
		while(nRows){
			nSel= m_pProg->vecPrograms[nextPr].nProgramSel;
			nRows= m_pProg->vecPrograms[nextPr].vecNextProgs.size();
			
			// test child programs
			for(i= 0; i < nRows; i++){
				// nextPr1 Program
				nextPr1= m_pProg->vecPrograms[nextPr].vecNextProgs[i];
				
				if( m_pProg->vecPrograms[nextPr1].coordRect.PtInRect(point) ){
					// found program by point - find Oper1
					nProg1= nextPr1;
					nOper1= (point.x - m_pProg->vecPrograms[nextPr1].coordRect.left) / m_xOperSize;
					return true;
				}
			}

			// go to selected child
			if(nSel < nRows)
				nextPr= m_pProg->vecPrograms[nextPr].vecNextProgs[nSel];
		}
	}
	return false;
}
//----------------------------------------------

void CProgramTree::OnLButtonDown(UINT nFlags, CPoint point)
{
	int nProg1, nOper1;
	point.Offset(m_xScrollPos, m_yScrollPos);
	
	if( FindOperByPoint(point, nProg1, nOper1) ){
		( (CProgramDlg*) GetParent() )->SetCurrentProg(m_pProg, this, nProg1, nOper1);
		m_nCurProg= nProg1;
		m_nCurOper= nOper1;
		
		int nPrParent= m_pProg->vecPrograms[nProg1].nProgParent;
		m_pProg->SelectChildProg(nPrParent, nProg1);
		RedrawClient();
	}

	CWnd::OnLButtonDown(nFlags, point);
}
//------------------------------------------------------
