// SceneView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "MaxFight.h"
#include "SceneView.h"
#include "MainFrm.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSceneView

CSceneView::CSceneView()
{
	m_pCurMan= &Human;

	Enemy.m_bEnemy= true;
	m_Drag= false;

	Enemy.InvertBody();
	Human.SetPosition( CPoint(150, VERT_POS) );
	Enemy.SetPosition( CPoint(400, VERT_POS) );
}

CSceneView::~CSceneView()
{
}


BEGIN_MESSAGE_MAP(CSceneView,CWnd )
	//{{AFX_MSG_MAP(CSceneView)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSceneView message handlers

BOOL CSceneView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CSceneView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	PaintClient(dc);
}

void CSceneView::PaintClient(CDC& dc)
{
	CRect rcClient;
	GetClientRect(&rcClient);

	CDC memDC;
	CBitmap bmpScreen;

	if(!memDC.CreateCompatibleDC(&dc) )
		return;
	if(!bmpScreen.CreateCompatibleBitmap(&dc, rcClient.right, rcClient.bottom) )
		return;
	// then select new picture to draw
	CBitmap* pOldBmp= memDC.SelectObject(&bmpScreen);

	// draw borders
	CBrush brush;
	brush.CreateSolidBrush( RGB(220, 220, 220) ); 
	CBrush *pOldBr= memDC.SelectObject(&brush);
	memDC.PatBlt(0, 0, rcClient.right, rcClient.bottom, PATCOPY);
	if(pOldBr)
		memDC.SelectObject(pOldBr);

	Human.DrawHuman(&memDC);
	Enemy.DrawHuman(&memDC);

	// we created picture in memDC, now copy it to screen
	dc.BitBlt(0, 0, rcClient.right, rcClient.bottom, &memDC, 0, 0, SRCCOPY);

	if(pOldBmp)
		memDC.SelectObject(pOldBmp);
}
//------------------------------------------------------

void CSceneView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CRgn Rgn;
	CMainFrame *pMain= (CMainFrame*) AfxGetMainWnd();
	for(int i= NUM_PARTS-1; i >= 0; i--){
		Rgn.DeleteObject();
		Human.GetPart(i)->GetRegion(Rgn);

		if(Rgn.PtInRegion(point) ){
			Human.SetCurrentPart(i);
			m_pCurMan= &Human;

			m_Drag= true;
			m_ptLast= point;
			RedrawClient();

			SetCapture();
			pMain->m_CurMan= m_pCurMan;
			pMain->m_nCurPart= i;
			break;
		}
		
		Rgn.DeleteObject();
		Enemy.GetPart(i)->GetRegion(Rgn);
		if(Rgn.PtInRegion(point) ){
			Enemy.SetCurrentPart(i);
			m_pCurMan= &Enemy;

			m_Drag= true;
			m_ptLast= point;
			RedrawClient();

			SetCapture();
			pMain->m_CurMan= m_pCurMan;
			pMain->m_nCurPart= i;
			break;
		}
	}

	CWnd ::OnLButtonDown(nFlags, point);
}

void CSceneView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(!m_Drag)
		return;
	m_Drag= false;
	ReleaseCapture();
	
	CWnd ::OnLButtonUp(nFlags, point);
}

void CSceneView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(!m_Drag)
		return;

	int dx= m_ptLast.x - point.x;
	int dy= m_ptLast.y - point.y;
	int nAdd= (int) sqrt(dx*dx + dy*dy);
	if(dx < 0)
		nAdd= -nAdd;
	
	if(m_pCurMan)
		m_pCurMan->AddAngle(nAdd);

	RedrawClient();
	m_ptLast= point;

	CWnd ::OnMouseMove(nFlags, point);
}
//------------------------------------------------------

void CSceneView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CMainFrame *pMain= (CMainFrame*) AfxGetMainWnd();
	pMain->OnSelectPart();

	CWnd ::OnLButtonDblClk(nFlags, point);
}
